package com.base.locationsharewhite.helper

import FCMManager
import android.app.Activity
import android.app.Application
import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import com.base.locationsharewhite.ads.AdsConfigBean
import com.base.locationsharewhite.ads.AdsMgr
import com.base.locationsharewhite.fcm.BatteryStatusReceiver
import com.base.locationsharewhite.fcm.PackageStatusReceiver
import com.base.locationsharewhite.fcm.ScreenStatusReceiver
import com.base.locationsharewhite.fcm.alarm.AlarmUtils.startAlarm
import com.base.locationsharewhite.helper.config.AppConfig
import com.base.locationsharewhite.service.StayJobService.Companion.startJob
import com.base.locationsharewhite.ui.splash.SplashActivity
import com.base.locationsharewhite.utils.AppPreferences
import com.base.locationsharewhite.utils.LogEx
import java.util.Locale
import java.util.UUID


class MyApplication : Application() {
    private val TAG = "MyApplication"
    var uuid = ""

    companion object {

        lateinit var appContext: MyApplication

        var splashLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var mainLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var setLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var settingsLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var howUseLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var renameLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country
        var locationMapLanguage: String = Locale.getDefault().language + "_" + Locale.getDefault().country

        var umpCanAd: Boolean = true

        @JvmField
        var PAUSED_VALUE = 0
    }


    override fun onCreate() {
        super.onCreate()
        appContext = this
        initUUid()
        initApp()
    }

    private fun initUUid() {
        uuid = AppPreferences.getInstance().getString("uuid", "")
        if (TextUtils.isEmpty(uuid)) {
            uuid = UUID.randomUUID().toString() + System.currentTimeMillis()
            AppPreferences.getInstance().put("uuid", uuid)
            LogEx.logDebug(TAG, "uuid=$uuid")
        }
        LogEx.logDebug(TAG, "uuid=${AppPreferences.getInstance().getString("uuid", "")}")
    }

    private fun initApp() {
//        FacebookSdk.sdkInitialize(applicationContext)
        val topic = AppConfig.packageName + "_push"
        LogEx.logDebug(TAG, "topic=${topic}")
        FCMManager.initFirebase(this)
        FCMManager.subscribeToTopic(topic)
        InstallHelps.init()
        initAdSdk()
        initLifeListener()

        ScreenStatusReceiver.registerScreenStatusReceiver(this)
        PackageStatusReceiver.registerPackageStatusReceiver(this)
        BatteryStatusReceiver.registerBatteryStatusReceiver(this)

        startJob()
        startAlarm(appContext)


//        val popupJson = createDefaultPopupJson()
//        val adJson = createDefaultAdJson()
//        val allJons = adJson.pullAll(popupJson)
//        LogEx.logDebug(TAG, "allJons=$allJons")

    }


    private var lastTimePause = 0L
    private var lastTimeResume = 0L
    private fun isHotLaunch(): Boolean {
        if ((lastTimeResume - lastTimePause) > 5000) {
            return true
        }
        return false
    }

    private fun initLifeListener() {
        registerActivityLifecycleCallbacks(object : ActivityLifecycleCallbacks {
            private var count = 0
            override fun onActivityCreated(activity: Activity, savedInstanceState: Bundle?) {
                ActivityManagerUtils.getInstance().addActivity(activity)
            }

            override fun onActivityStarted(activity: Activity) {
                count++
                lastTimeResume = System.currentTimeMillis()
                if (count == 1 && isHotLaunch()) {

                    val topActivity: Activity? = ActivityManagerUtils.getInstance().topActivity

                    val flag = if (topActivity == null) {
                        true
                    } else {
                        AppConfig.noLoadingActivities.all { !topActivity.localClassName.contains(it, true) }
                    }

                    LogEx.logDebug(TAG, "flag=$flag" + "   activity:" + activity.localClassName)

                    if (flag) {
                        topActivity?.startActivity(
                            Intent(
                                topActivity, SplashActivity::class.java
                            ).apply {
                                putExtra("isHotLaunch", true)
                                putExtra("type", -1)
                            })
                    }
                }
                lastTimeResume = 0
            }

            override fun onActivityResumed(activity: Activity) {
//                LogEx.logDebug(TAG, "onActivityResumed")
                PAUSED_VALUE = 1
            }


            override fun onActivityPaused(activity: Activity) {
//                LogEx.logDebug(TAG, "onActivityPaused")
                PAUSED_VALUE = 2
                lastTimePause = System.currentTimeMillis()
            }

            override fun onActivityStopped(activity: Activity) {
                count--
            }

            override fun onActivitySaveInstanceState(activity: Activity, outState: Bundle) {}

            override fun onActivityDestroyed(activity: Activity) {
                ActivityManagerUtils.getInstance().removeActivity(activity)
            }
        })
    }

    private fun initAdSdk() {
        val adsConfigBean = AdsConfigBean.getSpConfigBean()
        //初始化广告相关业务
        AdsMgr.init(appContext, adsConfigBean)
    }

}